# Minor optimization to reduce @a calls - expand on this later
execute as @a run function essences:player/general_tick
# Focus rework - Focus regen now in player/general_tick
function essences:power/display
#

execute store result score es.gametime es.misc run time query gametime



#
scoreboard players add 5s es.5sec 1
scoreboard players add 5s es.6tic 1
execute if score 5s es.5sec matches 100 run scoreboard players set 5s es.5sec 0
execute if score 5s es.6tic matches 6 run scoreboard players set 5s es.6tic 0

# Detect player logins
execute as @a[scores={es.esslogout=1..}] run function essences:player/login
#

# Sneak input related
execute as @a[scores={es.sneaktick=1..}] run function essences:sneaklookup

execute as @a[scores={es.sneaktick=0,es.eruptcharge=1..}] run function essences:player/emp/sneak/ability/erupt/lookup
execute as @a[scores={es.eruptcharge=1..}] unless entity @s[predicate=essences:empower/mainhand] unless entity @s[predicate=essences:empower/offhand] run function essences:player/emp/sneak/ability/erupt/anticheese
#

# Jump input related
execute as @a[predicate=essences:airborne] run scoreboard players add @s es.airtime 1
execute as @a[scores={es.jumptick=1..}] run function essences:jumplookup
execute as @a[tag=es.jumptick.process] run function essences:player/input/jump
#

# Hidden arts cooldown
execute as @a[scores={es.ha.cd=1..}] run scoreboard players remove @s es.ha.cd 1

# Omnidextrous trait
scoreboard players set @a es.omnidex.triggercount 0

# Enrage
execute as @a[tag=es.emp.enraged] at @s run function essences:player/emp/sneak/ability/enrage/tick
# Brace (for BOTH sneak and jump variants)
execute as @a[tag=es.emp.braced] at @s run function essences:player/emp/sneak/ability/brace/lookup
# Collude (for BOTH sneak and jump variants)
execute as @a[tag=es.emp.colluding] at @s run function essences:player/emp/sneak/ability/collude/lookup
# Recoup (jump only - sneak doesn't need this)
execute as @a[tag=es.emp.recouping] at @s run function essences:player/emp/sneak/ability/recoup/lookup
# Rejuvenate (for BOTH sneak and jump variants)
execute as @a[tag=es.emp.rejuvenating] at @s run function essences:player/emp/sneak/ability/rejuvenate/lookup
# Upwind
execute as @a[tag=es.emp.upwinding] at @s run function essences:player/emp/sneak/ability/upwind/smoketrail
# Harvest
execute as @a[scores={es.sneaktick=0},tag=es.emp.303.sn.init] run function essences:player/emp/sneak/ability/harvest/end
execute as @a[tag=es.emp.harvesting] at @s run function essences:player/emp/jump/ability/harvest/tick

### Truth and arrows
execute as @e[tag=!smithed.entity,type=arrow,tag=!es.arrow] at @s run function essences:arrows/bufftype
execute as @e[tag=!smithed.entity,type=spectral_arrow,tag=!es.arrow] at @s run function essences:arrows/spectral

### first login
execute if score rate es.packload matches 1 as @a[tag=!es.firstlogin] run function essences:firstlogin
###

execute as @a store result score @s es.hunger run data get entity @s foodLevel 1

### right click use items
execute as @a[scores={es.essence_used=1..}] run function essences:channelers/pre

### timers/cds for ceremony
execute as @a[scores={es.saccd=1..}] run scoreboard players remove @s es.saccd 1
execute as @a[scores={es.sustimer=1..}] at @s run function essences:channelers/hl/ceremony/sustain_tick
execute as @a[scores={es.fftimer=1..}] at @s run function essences:channelers/hl/ceremony/fleetfoot_tick

### fishing rod major augs
execute as @a[scores={es.rod_use=1..}] at @s run function essences:player/rod_use
execute as @e[type=minecraft:fishing_bobber,tag=es.tickinghook] at @s run function essences:player/rod/tick_pointer

### EP item consumption
execute as @a[tag=es.in_ep_combo] run function essences:misc/epdeposit/main
execute as @a[nbt={Inventory:[{id:"minecraft:structure_block", tag:{esitemgroup:epdrop}}]}] at @s run function essences:misc/epdeposit/inv/pickup

### Affliction - change this later during Morning phase
effect clear @a[tag=es.afflicted] minecraft:poison
effect clear @a[tag=es.afflicted] minecraft:slowness
execute as @a[tag=es.afflicted,scores={es.killtick=1..}] run function essences:afflictionfeed
scoreboard players set @a es.killtick 0
execute as @a[tag=es.afflicted,scores={es.hp=..0}] run function essences:afflictiondeath

### Guard Break (now triggered in take_dmg and shieldblocked)
#execute as @a[gamemode=!spectator] run function essences:guardbreak/main

### Attribute damage timer
execute as @a[scores={es.attdmginvuln=1..}] run scoreboard players remove @s es.attdmginvuln 1

### Scheduled Player Events
execute as @a if entity @s[tag=es.playerevent] run function essences:player/schedevents/lookup

# (yes it is important that this score is set after schedevents are handled)
scoreboard players set @a es.sneaktick 0

### Augment table
execute as @e[type=armor_stand,tag=es.augmenttable,tag=es.augmenttableprimer] at @s run function essences:augmenttable/set
execute as @a[scores={es.augtableuse=1..}] at @s run function essences:augmenttable/activate

### Hostile mob processing - assign variants, run tick behavior
execute as @e[type=#essences:has_variant,tag=!smithed.strict,tag=!smithed.entity,tag=!es.mobvar.generic,tag=!es.summoned] at @s if entity @a[distance=..100,scores={es.activediff=2..},gamemode=!spectator] run function essences:mobvar/process/main
execute as @e[type=#essences:has_variant,tag=es.mobvar.generic] at @s run function essences:mobvar/1t

### Generic ticking entity - ALWAYS the last thing every tick.
execute as @e[tag=es.ticking_entity] at @s run function essences:ticking_entity